// All of the Node.js APIs are available in the preload process.
// It has the same sandbox as a Chrome extension.

//import necessary modules
const electron = require('electron');
const contextBridge = electron.contextBridge;
const ipcRenderer = electron.ipcRenderer;
const dialog = electron.dialog;
const fs = require('fs');
const path = require('path');
const os = require('os');

contextBridge.exposeInMainWorld(
    'app', {
        fs: {
            readFile: function (a, encoding, callback) {
                fs.readFile(a, encoding, callback);
            },
            writeFile: function (a, content, encoding, callback) {
                fs.writeFile(a, content, encoding, callback);
            },
            existsSync: function (a) {
                return fs.existsSync(a);
            }
        },
        path: {
            basename: function (a) {
                return path.basename(a);
            },
            normalize: function (a) {
                return path.normalize(a);
            }
        },
        os: {
            homedir: function () {
                return os.homedir();
            }
        },
        ipcRenderer: {
            invoke: function (a, b) {
                return ipcRenderer.invoke(a, b);
            },
            sendToHost: function (a, b) {
                return ipcRenderer.sendToHost(a, b);
            }
        },
        electronDialog: {
            showOpenDialog: function (a) {
                return dialog.showOpenDialog(a);
            }
        }
    }
);
contextBridge.exposeInMainWorld(
    'process', {
        platform: process.platform,
        env: {
            APPDATA: process.env.APPDATA
        }
    }
);